**********************************************************
** <--------> Macros Made By BiGWiG / iNSANe <--------> **
** <----> Last Edited On The 26 Of February 1994 <----> **
**********************************************************

		jmp	Start

**********************************************************
** <--> Wait For A Specific Vertical Line <-----------> **
**********************************************************
; Send Following parameters :
;
; Line To Wait For,Dx-Register To Use
;
WLINE		MACRO
.loop\@		move.l	$dff004,\2
		and.l	#$1ff00,\2
		cmp.l	#\1<<8,\2
		bne.s	.loop\@
		ENDM

**********************************************************
** <--> Wait For The Blitter To Finish <--------------> **
**********************************************************
BLTWAIT		MACRO
.BltBusy\@	btst	#6,$dff002
		bne.s	.BltBusy\@
		ENDM

**********************************************************
** <--> Wait Show Time + Test Left Mouse <------------> **
**********************************************************
MOUSE		MACRO
		btst	#10,$dff016
		bne.s	.NoRight\@
		move.w	#0,$dff106
		move.w	#$0f0f,$dff180
.NoRight\@
		btst	#6,$bfe001
		ENDM
		
**********************************************************
** <--> Change BackGround Color <---------------------> **
**********************************************************
; Send Following Parameters
;
; Color			( Only in whole 16 steps ( No AGA Colors) )
;
BACKCOL		MACRO
		move.w	#$0000,$dff106
		move.w	#\1,$dff180
		ENDM

**********************************************************
** <--> Clear Memory With Blitter <-------------------> **
**********************************************************
; Send Following parameters :
;
; D-Pointer,Height,Bytes,Dmodulo
;
BLTCLR		MACRO
		BLTWAIT
		move.l	#$01000000,$40(a6)
		move.l	#0,$44(a6)
		move.l	\1,$54(a6)
		move.w	#\4,$66(a6)
		move.w	#[\2*64]+[\3/2],$58(a6)
		ENDM

**********************************************************
** <--> Fill Memory With Blitter <--------------------> **
**********************************************************
; Send Following parameters :
;
; A-Pointer,DPointer,Height,Bytes,Amodulo,Dmodulo
;
BLTFILL		MACRO
		move.l	\1,d0
		move.l	\2,d1
		add.l	#[\3*\4]-2,d0
		add.l	#[\3*\4]-2,d1
		BLTWAIT
		move.l	#$09f00012,$40(a6)
		move.l	#-1,$44(a6)
		move.l	d0,$50(a6)
		move.l	d1,$54(a6)
		move.w	#\5,$64(a6)
		move.w	#\6,$66(a6)
		move.w	#[\3*64]+[\4/2],$58(a6)
		ENDM

**********************************************************
** <--> Plot A Dot <----------------------------------> **
**********************************************************
; Send Following Parameters:
;
; ScrPtr,ScrBytes	d0 => XKoord .. d1 => YKoord
;
PLOT		MACRO
		movem.l	d0-d2/a0,-(sp)
		move.l	\1,a0
		move.w	d0,d2
		mulu.w	#\2,d1
		lsr.w	#3,d0
		add.w	d0,d1
		and.b	#$7,d2
		not.b	d2
		bset    d2,(a0,d1.w)
		movem.l (sp)+,d0-d2/a0
		ENDM

**********************************************************
** <--> Init CopperRegisters For Bitplanes <----------> **
**********************************************************
; Send Following parameters :
;
; BplCon0 Address,ScrPtr,ScrDepth,ScrSize,Hires,Lace
;
COPMAC		MACRO
		move.w	#\3,d7
		move.w	#\5,d5
		move.w	#\6,d6
		cmp.w	#7,d7
		ble.s	.NotEight\@
		move.w	#$0210,d0
		bra	.Cont\@

.NotEight\@	move.w	#\3<<12,d0
		add.w	#$0200,d0

.Cont\@		tst.w	d5
		beq.s	.NoHires\@
		cmp.w	#2,d5
		bne.s	.NoSuperHi\@
		add.w	#$0020,d0
		bra	.NoHires\@

.NoSuperHi\@	add.w	#$8000,d0

.NoHires\@	tst.w	d6
		beq.s	.NoLace\@
		add.w	#$0004,d0

.NoLace\@	Lea.l	\1,a0
		move.w	#$0100,(a0)+
		move.w	d0,(a0)+
		move.l	\2,d0
		move.l	#$00e00000,d1
		subq.w	#1,d7

.BplLoop\@	swap	d0
		move.w	d0,d1
		move.l	d1,(a0)+
		swap	d0
		add.l	#$00020000,d1
		move.w	d0,d1
		move.l	d1,(a0)+
		add.l	#$00020000,d1
		add.l	#\4,d0
		dbf	d7,.BplLoop\@
		ENDM

**********************************************************
** <--> Init Bplcon Regs In Copperlist
**********************************************************
; Send Following Parameters:
;
; Bpl1Con,Bpl0Con,ScrPtr,ScrDepth,ScrSize,Hires,Lace,Ham 
;
; Bpl1Con  <- Address To First BplCon In Copperlist
; Bpl0Con  <- Address To BplCon0 In Copperlist
; ScrPtr   <- Pointer To Screen To Be Shown
; ScrDepth <- Number Of BitPlanes
; ScrSize  <- Size Of A BitPlane In Bytes
; Hires    <- 0=LowRes, 1=Hires, 2=UltraHires, 3=SuperHires
; Lace     <- 0=No InterLace, 1=InterLaced
; Ham      <- 0=No Ham, 1=Ham, 2=Extra Halfbrite

INITCOP		MACRO
		lea	\1,a0
		move.l	\3,d2

		move	#$0201,d1
		move	#\6,d0
.BplCon\@	btst	#0,d0
		beq.w	.NoHires\@
		add	#$8000,d1		;Set Hires In BplCon0

.NoHires\@	btst	#1,d0
		beq.w	.NoUltra\@
		add	#$0080,d1		;Set UltraHires In BplCon0

.NoUltra\@	btst	#2,d0
		beq.w	.NoSuper\@
		add	#$0040,d1		;Set SuperHires In BplCon0

.NoSuper\@	move.w	#\7,d0
		beq.w	.NoLace\@
		add	#$0004,d1		;Set Lace In BplCon0

.NoLace\@	move	#\4,d0
		cmp	#8,d0
		blt.w	.NoEightBpls\@
		add	#$0010,d1		;Set Bpu3 In BplCon0
		moveq	#0,d0

.NoEightBpls\@	ror.w	#4,d0			;Shift The ScrDepht
		add	d0,d1			;Add Right Numbers Of Bpls

		move	#\8,d0
		bne.w	.HamOrHb\@

		and.w	#$feff,6(a0)
		bra.w	.WriteBplCon\@

.HamOrHb\@	btst	#1,d0
		beq.w	.NoHam\@
		add	#$8000,d1
		add.w	#$feff,6(a0)
		bra.w	.WriteBplCon\@

.NoHam\@	btst	#2,d0
		beq.w	.WriteBplCon\@
		add.w	#$0100,6(a0)

.WriteBplCon\@	lea	\2,a0

		move.w	#$0100,(a0)+
		move.w	d1,(a0)+
		move	#\5,d3
		ext.l	d3

.BplPtrs\@	move.w	#$00e0,d1
		move.w	#\4-1,d7

.BplPtrLoop\@	move.w	d1,(a0)+
		swap	d2
		move.w	d2,(a0)+
		addq	#2,d1
		move.w	d1,(a0)+
		swap	d2
		move.w	d2,(a0)+
		add.l	d3,d2
		addq	#2,d1
		dbf	d7,.BplPtrLoop\@
		ENDM

**********************************************************
** <--> Init Colors For The CopperList <--------------> **
**********************************************************
; Send Following Parameters:
;
; ColCop,ColTab2,ScrDepth,AgaColor  AgaColor=2 ColorList In $00112233 Format
;				    Red = $11, Green = $22, Blue = $33
;

INITCOL		MACRO
		lea	\1,a0
		lea	\2,a1
		move.w	#\4,d0
		bne.w	.AgaColors\@
		move.l	#$01060000,d1
		move.l	#$01060200,d2
		move.w	#$0180,d0
		move.w	#2^\3,d7
		cmp.w	#32,d7
		ble.w	.Only1Bank\@
		lea	(a0,d7.w*4),a2
		lsr.w	#5,d7		;Antal Banker
		lea	(a2,d7.w*4),a2
		subq	#1,d7
.Bank1Loop\@	move.l	d1,(a0)+
		move.l	d2,(a2)+
		move	#32-1,d6
.NoAgaLoop\@	move.w	d0,(a0)+
		move.w	(a1)+,(a0)+
		move.w	d0,(a2)+
		move.w	#$0,(a2)+
		addq	#2,d0
		dbf	d6,.NoAgaLoop\@
		move.w	#$0180,d0
		add.l	#$00002000,d1
		add.l	#$00002000,d2
		dbf	d7,.Bank1Loop\@
		bra.w	.Exit\@
.Only1Bank\@	subq	#1,d7
		lea	8(a0,d7.w*4),a2
		move.l	d1,(a0)+
		move.l	d2,(a2)+
.ColorLoop\@	move.w	d0,(a0)+
		move.w	(a1)+,(a0)+
		move.w	d0,(a2)+
		move.w	#0,(a2)+
		addq	#2,d0
		dbf	d7,.ColorLoop\@
		bra.w	.Exit\@
.AgaColors\@	btst	#1,d0
		bne.w	.24BitCols\@
		move.l	#$01060000,d1
		move.l	#$01060200,d2
		move.w	#$0180,d0
		move.w	#2^\3,d7
		cmp.w	#32,d7
		ble.w	.Only2Bank\@
		lea	(a0,d7.w*4),a2
		lsr.w	#5,d7		;Antal Banker
		lea	(a2,d7.w*4),a2
		subq	#1,d7
.Bank2Loop\@	move.l	d1,(a0)+
		move.l	d2,(a2)+
		move	#32-1,d6
.Aga1Loop\@	move.w	d0,(a0)+
		move.w	(a1)+,(a0)+
		move.w	d0,(a2)+
		move.w	(a1)+,(a2)+
		addq	#2,d0
		dbf	d6,.Aga1Loop\@
		move.w	#$0180,d0
		add.l	#$00002000,d1
		add.l	#$00002000,d2
		dbf	d7,.Bank2Loop\@
		bra.w	.Exit\@
.Only2Bank\@	subq	#1,d7
		lea	8(a0,d7.w*4),a2
		move.l	d1,(a0)+
		move.l	d2,(a2)+
.Color2Loop\@	move.w	d0,(a0)+
		move.w	(a1)+,(a0)+
		move.w	d0,(a2)+
		move.w	(a1)+,(a2)+
		addq	#2,d0
		dbf	d7,.Color2Loop\@
		bra.w	.Exit\@
.24BitCols\@	move.l	#$01060000,d1
		move.l	#$01060200,d2
		move.w	#$0180,d0
		move.w	#2^\3,d7
		cmp.w	#32,d7
		ble.w	.Only3Bank\@
		lea	(a0,d7.w*4),a2
		lsr.w	#5,d7		;Antal Banker
		lea	(a2,d7.w*4),a2
		subq	#1,d7
		moveq	#0,d3
		moveq	#0,d4
.Bank3Loop\@	move.l	d1,(a0)+
		move.l	d2,(a2)+
		move.w	#32-1,d6
.Aga2Loop\@	move.b	(a1)+,d3
		move.b	(a1),d3		;Get Red Color LowBits
		and.w	#$f,d3
		lsl.w	#8,d3
		move	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Red Color HighBits
		and.w	#$f0,d3
		lsl.w	#4,d3
		move	d3,d4		;High Bits
		move.b	(a1),d3		;Get Green Color LowBits
		and.w	#$f,d3
		lsl.w	#4,d3
		add	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Green Color High Bits
		and.w	#$f0,d3
		add	d3,d4		;High Bits
		move.b	(a1),d3		;Get Blue Color LowBits
		and.w	#$f,d3
		add	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Blue Color High Bits
		and.w	#$f0,d3
		lsr.w	#4,d3
		add	d3,d4		;High Bits
		move	d0,(a0)+
		move	d4,(a0)+
		move	d0,(a2)+
		move	d5,(a2)+
		addq	#2,d0
		dbf	d6,.Aga2Loop\@
		move	#$0180,d0
		add.l	#$00002000,d1
		add.l	#$00002000,d2
		dbf	d7,.Bank3Loop\@
		bra.w	.Exit\@
.Only3Bank\@	subq	#1,d7
		lea	8(a0,d7.w*4),a2
		move.l	d1,(a0)+
		move.l	d2,(a2)+
.Color3Loop\@	move.b	(a1)+,d3
		move.b	(a1),d3		;Get Red Color LowBits
		and.w	#$f,d3
		lsl.w	#8,d3
		move	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Red Color HighBits
		and.w	#$f0,d3
		lsl.w	#4,d3
		move	d3,d4		;High Bits
		move.b	(a1),d3		;Get Green Color LowBits
		and.w	#$f,d3
		lsl.w	#4,d3
		add	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Green Color High Bits
		and.w	#$f0,d3
		add	d3,d4		;High Bits
		move.b	(a1),d3		;Get Blue Color LowBits
		and.w	#$f,d3
		add	d3,d5		;Low Bits
		move.b	(a1)+,d3	;Get Blue Color High Bits
		and.w	#$f0,d3
		lsr.w	#4,d3
		add	d3,d4		;High Bits
		move	d0,(a0)+
		move	d4,(a0)+
		move	d0,(a2)+
		move	d5,(a2)+
		addq	#2,d0
		dbf	d7,.Color3Loop\@
.Exit\@
		ENDM

**********************************************************
** <--> Init Colors For The Copperlist <--------------> **
**********************************************************
; Send Following parameters :
;
; ColCop,ColTab,2^ScrDepth
;
COLMAC		MACRO
		lea	\1,a0
		lea	\2,a1
		move.w	#$0180,d4
		move.w	#\3,d7
		subq.w	#1,d7
.loop\@
		move.w	(a1)+,d0	;Red
		move.w	d0,d1
		and.w	#$f,d1
		and.w	#$f0,d0
		lsl.w	#4,d0
		lsl.w	#8,d1
		move.w	(a1)+,d2	;Green
		move.w	d2,d3
		and.w	#$f,d3
		and.w	#$f0,d2
		lsl.w	#4,d3
		add.w	d2,d0
		add.w	d3,d1
		move.w	(a1)+,d2	;Blue
		move.w	d2,d3
		and.w	#$f,d3
		and.w	#$f0,d2
		lsr.w	#4,d2
		add.w	d2,d0
		add.w	d3,d1
		move.l	#$01060000,(a0)+
		move.w	d4,(a0)+
		move.w	d0,(a0)+
		move.l	#$01060200,(a0)+
		move.w	d4,(a0)+
		move.w	d1,(a0)+
		addq.w	#2,d4
		dbf	d7,.loop\@
		ENDM

**********************************************************
** <--> Init Colors For The Copperlist <--------------> **
**********************************************************
; Send Following parameters :
;
; ColCop,ColTab,2^ScrDepth,AgaColor	-> AgaColor = 1 => On
;
COLMAC2		MACRO
		lea	\1,a0
		lea	\2,a1
		move	#\3,d7
		subq	#1,d7
		move	#$0180,d4
		move	#\4,d6
		tst	d6
		beq	.NoAgaLoop\@
.AgaLoop\@
		move.l	#$01060000,(a0)+
		move	d4,(a0)+
		move	(a1)+,(a0)+
		move.l	#$01060200,(a0)+
		move	d4,(a0)+
		move	(a1)+,(a0)+
		addq	#2,d4
		dbf	d7,.AgaLoop\@
		bra	.MacEnd\@
.NoAgaLoop\@
		move.l	#$01060000,(a0)+
		move	d4,(a0)+
		move	(a1)+,(a0)+
		move.l	#$01060200,(a0)+
		move	d4,(a0)+
		move	#0,(a0)+
		addq	#2,d4
		dbf	d7,.NoAgaLoop\@
.MacEnd\@
		ENDM

**********************************************************
** <--> FADE ROUTINE <--------------------------------> **
**********************************************************
;
; Send Following Parameters
;
; FADE3	ColCopPtr,ColTabPtr,2^ScrDepth,Up,Steps,AgaColor
;
;	This Routine Fades From ColTables Containing Either
;	AGA-Colors in Format -> Whole,1/16-parts <-  OR
;	NonAga Colors in Format -> Whole <- (Like IffMaster)
;

FADE3		MACRO
		move	#\6,d6
		move.l	\2,a0
		move.l	\1,a1
		move	#\3,d7
		subq	#1,d7
.loop\@
		move	(a0)+,d0
		move	d0,d1
		move	d0,d2
		and.w	#$0f00,d0
		lsr.w	#4,d0
		and.w	#$00f0,d1
		and.w	#$000f,d2
		lsl.w	#4,d2
		tst	d6
		beq	.NonAgA

		move	(a0)+,d3
		move	d3,d4
		move	d3,d5
		and.w	#$0f00,d3
		lsr.w	#8,d3
		and.w	#$00f0,d4
		lsr.w	#4,d4
		and.w	#$000f,d5
		add	d3,d0		=> Total AGA Red
		add	d4,d1		=> Total AGA Green
		add	d5,d2		=> Total AGA Blue
.NonAga		
		mulu	Intensity,d0
		lsr	#8,d0
		mulu	Intensity,d1
		lsr	#8,d1
		mulu	Intensity,d2
		lsr	#8,d2
		move	d0,d3
		move	d1,d4
		move	d2,d5
		and.w	#$00f0,d0
		lsl.w	#4,d0
		and.w	#$00f0,d1
		and.w	#$00f0,d2
		lsr.w	#4,d2
		add	d1,d0
		add	d2,d0
		move	d0,6(a1)

		and.w	#$000f,d3
		lsl.w	#8,d3
		and.w	#$000f,d4
		lsl.w	#4,d4
		and.w	#$000f,d5
		add	d4,d3
		add	d5,d3
		move	d3,14(a1)

		add.l	#16,a1

		dbf	d7,.loop\@
		move	#\4,d0
		beq	.NotUp\@

		add	#\5,Intensity
		bra	.NoMore\@
.NotUp\@
		sub	#\5,Intensity
.NoMore\@
		ENDM

**********************************************************
** <--> Fade Colours Up & Down <----------------------> **
**********************************************************
; Send Following parameters :
;
; ColCopPtr,ColTabPtr,2^ScrDepth,Up,Steps
; OBS! The Intensity always starts at 1. So you have to set the
; Intensity value before fading down if you havent faded up before.
;
FADE		MACRO
		move.l	\1,a0
		move.l	\2,a1
		move.w	#\4,d6
		move.w	Intensity,d5
		move.w	#\3-1,d7
.loop\@
		move.w	(a1)+,d0	;Red
		mulu.w	d5,d0
		lsr.w	#8,d0
		move.w	d0,d1
		and.w	#$f,d1
		and.w	#$f0,d0
		lsl.w	#4,d0
		lsl.w	#8,d1
		move.w	(a1)+,d2	;Green
		mulu.w	d5,d2
		lsr.w	#8,d2
		move.w	d2,d3
		and.w	#$f,d3
		and.w	#$f0,d2
		lsl.w	#4,d3
		add.w	d2,d0
		add.w	d3,d1
		move.w	(a1)+,d2	;Blue
		mulu.w	d5,d2
		lsr.w	#8,d2
		move.w	d2,d3
		and.w	#$f,d3
		and.w	#$f0,d2
		lsr.w	#4,d2
		add.w	d2,d0
		add.w	d3,d1
		move.w	d0,6(a0)
		move.w	d1,14(a0)
		add.l	#16,a0
		dbf	d7,.loop\@

		move.w	#\5,d4
		tst.w	d6
		bne.s	.Up\@
.Down\@
		sub.w	#\5,Intensity
		bgt.s	.Cont\@
		move.w	#1,Intensity
		bra.s	.Cont\@
.Up\@
		add.w	#\5,Intensity
		cmp.w	#256,Intensity
		blt.s	.Cont\@
		move.w	#256,Intensity
.Cont\@
		ENDM

**********************************************************
** <--> Clip Routine For Vectors <--------------------> **
**********************************************************
; Klippning av en linje efter ett visst vrde specificerat
; i parameter 1 dvs ClipX1 eller ClipX2. Anvndes lmp-
; ligast med rutinen FixLines.
;
;	d0 = x1
;	d1 = y1
;	d2 = x2
;	d3 = y2
;	\1 = ClipX-Vrdet
;
; Svaret terkommer i register d4. Dr vrdet r den strcka
; som KlippY-Koordinaten skall befinna sig frn y1 p.
;
ClipX		MACRO
		move.w	d3,d5	;y2 -> d5
		move.w	\1,d4	;ClipX -> d4
		move.w	d2,d6	;x2 -> d6
		sub.w	d2,d4	;a -> d4 ==> ClipX-x2
		sub.w	d1,d5	;B -> d5 ==> y2-y1
		sub.w	d0,d6	;A -> d6 ==> x2-x1
		muls.w	d5,d4	;a*B -> d4
		divs.w	d6,d4	;a*B/A -> d4 ==> b kommer tillbaks i d4
		ENDM

**********************************************************
** <--> Clip Routine For Vectors <--------------------> **
**********************************************************
; Klippning av en linje efter ett visst vrde specificerat
; i parameter 1 dvs ClipY1 eller ClipY2. Anvndes lmp-
; ligast med rutinen FixLines.
;
;	d0 = x1
;	d1 = y1
;	d2 = x2
;	d3 = y2
;	\1 = ClipY-Vrdet
;
; Svaret terkommer i register d4. Dr vrdet r den strcka
; som KlippX-Koordinaten skall befinna sig frn x1 p.
;
ClipY		MACRO
		move.w	d3,d5	;y2 -> d5
		move.w	\1,d4	;ClipY -> d4
		move.w	d2,d6	;x2 -> d6
		sub.w	d1,d4	;a -> d4 ==> ClipY-y1
		sub.w	d0,d6	;B -> d6 ==> x2-x1
		sub.w	d1,d5	;A -> d5 ==> y2-y1
		muls.w	d6,d4	;a*B -> d4
		divs.w	d5,d4	;a*B/A -> d4 ==> b kommer tillbaks i d4
		ENDM

**********************************************************
** <--> Kill The OS <---------------------------------> **
**********************************************************
; Should be called with BSR and NOT as a macro
;
SYSOFF
	move.l	$4.w,a6
	jsr	-132(a6)
	lea	GetVBR(pc),a5
	jsr	-30(a6)
	lea	VectorBasePtr(pc),a0
	move.l	d0,(a0)
	lea	Gfxname(pc),a1
	moveq.l	#0,d0
	jsr	-552(a6)		;OPEN GFX LIBRARY
	lea	Gfxbase(pc),a0
	move.l	d0,(a0)			;STORE GFXBASE
	move.l	d0,a6
	jsr	-228(a6)
	jsr	-456(a6)
	lea	Oldviews(pc),a0
	move.l	$26(a6),(a0)+
	move.l	$22(a6),(a0)
	suba.l	a1,a1
	jsr	-222(a6)
	jsr	-270(a6)
	jsr	-270(a6)
	lea	Olddatas(pc),a2
	lea	$dff000,a5
	move.w	$02(a5),(a2)+		;DMACONR
	move.w	$1e(a5),(a2)+		;INTREQR
	move.w	$1c(a5),(a2)		;INTENAR
	move.w	#$7fff,d0
	move.w	d0,$9a(a5)
	move.w	d0,$9c(a5)
	move.w	d0,$96(a5)
	lea	OldIntVectors(pc),a0
	move.l	VectorBasePtr(pc),a1
	adda.w	#$64,a1
	moveq.l	#10-1,d0
.loop	move.l	(a1)+,(a0)+
	dbf	d0,.loop
	move.w	#$8200,$96(a5)
	move.w	#$1843,$142(a5)
	move.l	4.w,a6
	btst.b	#2,$128(a6)
	bne.b	.notAGA
	move.w	#0,$106(a5)
.notAGA	rts
GetVBR:	move.w	$128(a6),d0
	btst.l	#0,d0
	beq.b	.noVBR
	dc.w	$4e7a,$0801	;movec	VBR,d0
.noVBR	rte

**********************************************************
** <--> Turn On The OS <------------------------------> **
**********************************************************
; Should be called with BSR and NOT as a macro
;
SYSON
	lea	OldIntVectors(pc),a0
	move.l	VectorBasePtr(pc),a1
	adda.w	#$64,a1
	moveq.l	#10-1,d0
.loop	move.l	(a0)+,(a1)+
	dbf	d0,.loop
	lea	$dff000,a5
	lea	Olddatas(pc),a0
	lea	Oldviews(pc),a1
	move.w	#$8000,d0
	move.l	(a1)+,$80(a5)
	or.w	d0,(a0)
	move.w	(a0)+,$96(a5)	;DMACON
	or.w	d0,(a0)
	move.w	(a0)+,$9c(a5)	;INTREQ
	or.w	d0,(a0)
	move.w	(a0),$9a(a5)	;INTENA
	move.l	Gfxbase(pc),a6
	move.l	(a1),a1
	jsr	-222(a6)
	jsr	-228(a6)
	jsr	-462(a6)
	move.l	$4.w,a6
	move.l	Gfxbase(pc),a1
	jsr	-414(a6)		;CLOSE GFX LIBRARY
	jsr	-138(a6)
	rts

		cnop	0,4
Gfxbase		ds.l	1
Oldviews	ds.l	2
VectorBasePtr	dc.l	0
OldIntVectors	ds.l	10
Olddatas	ds.w	3	;DMACON, INTREQ, INTENA
Gfxname		dc.b	"graphics.library",0

		EVEN

Intensity	dc.w	2

		EVEN

